//----------------------------------------------------------------------------------
//aviutlvOC Ȍo + Wv
// Copyright (c) 2005  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <mmintrin.h>
#include <ZMouse.h>

#include "filter.h"

#define ARRAYSIZE(a)  (sizeof(a)/sizeof((a)[0]))
#define ID_NEXT  1126
#define ID_PREV  1127
#define ID_STOP  1128
#define REW_N 64
#define SEARCH_NEXT 1
#define SEARCH_STOP 0

//---------------------------------------------------------------------
// func
//---------------------------------------------------------------------
int field_detect(PIXEL_YC *present, PIXEL_YC *ref, int h, int max_w, int w, int gain);
void go_prev(void *editp, FILTER *fp);
void go_prev(void *editp, FILTER *fp);

//---------------------------------------------------------------------
// grobal
//---------------------------------------------------------------------
int g_rew[REW_N];
int g_rew_head, g_rew_tail;
int g_gui_comm;

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 2
TCHAR *track_name[] = { "臒l", "gain" };
int   track_default[] = { 1, 0 };
int   track_s[] = { 0, 1 };
int   track_e[] = { 256, 12 };
enum  { T_TH, T_GAIN };

#define CHECK_N 1
TCHAR *check_name[] = { "Cxg𑗂" };
int    check_default[] = { 1 };
enum { C_SEND_EVENT };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_WINDOW_SIZE,
  320, 135,
  "ȌoWv",
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL, NULL, NULL,
  func_WndProc,
  NULL, NULL,
  NULL,
  0,
  "ȌoWv by N099, ver1.0",
  NULL,  NULL,

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  g_rew_head = g_rew_tail = g_gui_comm = 0;
  return &filter;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int c,n;
  PIXEL_YC *ref, *tgt;
  MSG msg;
  static TCHAR buff[256];

  //ۑ͉Ȃ
  if(fp->exfunc->is_saving(fpip->editp))
    return TRUE;
    
  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, 2, 0))
    return FALSE;

  if(SEARCH_NEXT == g_gui_comm){ //臒l܂ŃT[`
    c = -1;
    n = fpip->frame + 1;

    //݂̃t[𗚗ɒǉ
    if(g_rew_tail == g_rew_head){ //
      g_rew[g_rew_tail] = fpip->frame;
      ++g_rew_tail;
    }else{
      g_rew[g_rew_tail] = fpip->frame;
      g_rew_tail = REW_N-1==g_rew_tail ? 0 : g_rew_tail+1;
      if(g_rew_tail == g_rew_head)
        g_rew_head = REW_N-1==g_rew_head ? 0 : g_rew_head+1;
    }
    
    while(c <= fp->track[T_TH]){
      //bZ[W̏
      while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
        if(msg.message == WM_QUIT)  
          return FALSE; 

        DispatchMessage(&msg); 
      }

      if(!fp->exfunc->is_filter_active(fp) || !fp->exfunc->is_filter_window_disp(fp))
        g_gui_comm = SEARCH_STOP;
      
      if(n >= fpip->frame_n || SEARCH_STOP == g_gui_comm)
         break;
      
      ref = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, n-1, NULL, NULL);
      tgt = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, n,   NULL, NULL);
      if(ref && tgt){
        c = field_detect(tgt, ref, fpip->h, fpip->max_w, fpip->w, fp->track[T_GAIN]);
      }else{
        return FALSE;
      }

      if(0 == (n&15)){
        //olƌ݂̃t[\
        _sntprintf(buff, ARRAYSIZE(buff), _T("%s %d/%d :%d"),
                   filter.name, n, fpip->frame_n, c);
        buff[ ARRAYSIZE(buff) - 1] = 0;
        SetWindowText(fp->hwnd, buff);
      }
      
      ++n;
    }
    
    //t[XV
    g_rew[g_rew_tail] = n-1;
    g_rew_tail = REW_N-1==g_rew_tail ? 0 : g_rew_tail+1;
    if(g_rew_tail == g_rew_head)
      g_rew_head = REW_N-1==g_rew_head ? 0 : g_rew_head+1;

    //\
    g_gui_comm = SEARCH_STOP;
    fp->exfunc->set_frame(fpip->editp, n-1);
    SendMessage(fp->hwnd, WM_COMMAND, (BN_CLICKED<<16)|ID_STOP, 0);
  }else{ //ʏ펞
    ref = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame-1, NULL, NULL);
    tgt = fpip->ycp_edit;
    if(ref && tgt){
      c = field_detect(tgt, ref, fpip->h, fpip->max_w, fpip->w, fp->track[T_GAIN]);
    }else{
      return FALSE;
    }
  }
  
  //ol\
  _sntprintf(buff, ARRAYSIZE(buff), _T("%s :%d"),
             filter.name, c);
  buff[ ARRAYSIZE(buff) - 1] = 0;
  SetWindowText(fp->hwnd, buff);

  return TRUE;
}

//---------------------------------------------------------------------
//   ݒEBhE
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
  UNREFERENCED_PARAMETER(editp);
	
  switch(msg){
  case WM_COMMAND:
    switch(HIWORD(wparam)){
    case BN_CLICKED:
      switch(LOWORD(wparam)){
      case ID_NEXT:
        if(SEARCH_NEXT == g_gui_comm){
          return FALSE;
        }else if(fp->exfunc->is_filter_active(fp)){
          g_gui_comm = SEARCH_NEXT;
        }
        break;
      case ID_PREV:
        if(fp->exfunc->is_filter_active(fp)){
          g_gui_comm = SEARCH_STOP;
          go_prev(editp, fp);
        }
        break;
      case ID_STOP:
        g_gui_comm = SEARCH_STOP;
        break;
      default:
        return FALSE;
      }
      SetFocus(NULL);
      SetFocus(hwnd);
      return fp->exfunc->is_filter_active(fp);
    }
    break;
  case WM_ACTIVATE:
    if(WA_INACTIVE == wparam)
      g_gui_comm = SEARCH_STOP;
    break;
  case WM_KEYDOWN:
    if(fp->exfunc->is_filter_active(fp)){
      if(wparam == VK_DOWN){
        if(SEARCH_NEXT == g_gui_comm){
          return FALSE;
        }else{
          g_gui_comm = SEARCH_NEXT;
          return TRUE;
        }
      }else if(wparam == VK_UP){
        g_gui_comm = SEARCH_STOP;
        go_prev(editp, fp);
        return TRUE;
      }
    }
  case WM_KEYUP:
    if(wparam == VK_DOWN && fp->exfunc->is_filter_active(fp))
      break;
  case WM_MOUSEWHEEL:
    g_gui_comm = SEARCH_STOP;
    if(fp->check[C_SEND_EVENT])
      SendMessage(GetWindow(hwnd, GW_OWNER), msg, wparam, lparam);
    break;
  case WM_FILTER_INIT:
    CreateWindow(_T("BUTTON"), _T("next"),
                 WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
                 10, 86,
                 60, 20,
                 hwnd, (HMENU)ID_NEXT, fp->dll_hinst, NULL);
    CreateWindow(_T("BUTTON"), _T("prev"),
                 WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
                 80, 86,
                 60, 20,
                 hwnd, (HMENU)ID_PREV, fp->dll_hinst, NULL);
    CreateWindow(_T("BUTTON"), _T("stop"),
                 WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
                 150, 86,
                 60, 20,
                 hwnd, (HMENU)ID_STOP, fp->dll_hinst, NULL);
  }
  
  return FALSE;
}

//---------------------------------------------------------------------
//   ̑̊֐
//---------------------------------------------------------------------
// tB[hI[_[ogĎȂ̗L𔻒
int field_detect(PIXEL_YC *present, PIXEL_YC *ref, int h, int max_w, int w, int gain)
{
  int i,j;
  int diff_top = 0;
  int diff_btm = 0;
  short *pr, *re;
  __m64 pr0, pr1, pr2, re0, re1, re2, t1;
  
  //4pixelȓ̏ꍇ肵Ȃ
  if(h <= 4){
    return 0;
  }
  
  //[Ɖ[2Cv4C͖
  h -= 2;
  w *= sizeof(PIXEL_YC)/sizeof(short);
  max_w *= sizeof(PIXEL_YC)/sizeof(short);
  
  for(i=2; i<h; i+=2){
    int tmp_top = 0;
    int tmp_btm = 0;
    
    pr = (short *)(present) + i*max_w;
    re = (short *)(ref) + i*max_w;

    for(j=w; j>3; j-=4){
      //TOP 0
      pr0 = *(__m64 *)(pr - max_w);
      pr2 = *(__m64 *)(pr + max_w);
      re1 = *(__m64 *)re;
      //
      pr0 = _mm_adds_pi16(pr0 , pr2);
      pr0 = _mm_srai_pi16(pr0, 1);
      //
      pr0 = _mm_subs_pi16(pr0, re1);
      //Βl
      pr1 = _mm_srai_pi16(pr0, 15);
      pr0 = _mm_xor_si64(pr0, pr1);
      t1  = _mm_subs_pi16(pr0, pr1);
      
      //BTM 0
      pr1 = *(__m64 *)pr;
      re0 = *(__m64 *)(re - max_w);
      re2 = *(__m64 *)(re + max_w);
      //
      re0 = _mm_adds_pi16(re0, re2);
      re0 = _mm_srai_pi16(re0, 1);
      //
      re0 = _mm_subs_pi16(re0, pr1);
      //Βl
      pr0 = _mm_srai_pi16(re0, 15);
      re0 = _mm_xor_si64(re0, pr0);
      re0 = _mm_subs_pi16(re0, pr0);

      //BTM 1
      pr0 = *(__m64 *)(pr + max_w*2);
      //
      pr0 = _mm_adds_pi16(pr0, pr1);
      pr0 = _mm_srai_pi16(pr0, 1);
      //
      pr0 = _mm_subs_pi16(pr0, re2);
      //Βl
      pr1 = _mm_srai_pi16(pr0, 15);
      pr0 = _mm_xor_si64(pr0, pr1);
      pr0 = _mm_subs_pi16(pr0, pr1);
      //a
      pr0 = _mm_adds_pi16(pr0, re0);
      re0 = _mm_srli_si64(pr0, 32);
      pr0 = _mm_adds_pi16(pr0, re0);
      re0 = _mm_slli_si64(pr0, 16);
      pr0 = _mm_adds_pi16(pr0, re0);
      pr0 = _mm_srai_pi32(pr0, 16);
      
      tmp_btm += _mm_cvtsi64_si32(pr0);

      //TOP 1
      re0 = *(__m64 *)(re + max_w*2);
      //
      re0 = _mm_adds_pi16(re0, re1);
      re0 = _mm_srai_pi16(re0, 1);
      //
      re0 = _mm_subs_pi16(re0, pr2);
      //Βl
      re1 = _mm_srai_pi16(re0, 15);
      re0 = _mm_xor_si64(re0, re1);
      re0 = _mm_subs_pi16(re0, re1);    
      //a
      re0 = _mm_adds_pi16(re0, t1);
      pr0 = _mm_srli_si64(re0, 32);
      re0 = _mm_adds_pi16(re0, pr0);
      pr0 = _mm_slli_si64(re0, 16);
      re0 = _mm_adds_pi16(re0, pr0);
      re0 = _mm_srai_pi32(re0, 16);
 
      tmp_top += _mm_cvtsi64_si32(re0);

      
      pr+=4;
      re+=4;
    }
    //c
    for( ; j>0; --j){
      tmp_top += abs(*re - ((*(pr - max_w) + *(pr + max_w)) >> 1));
      tmp_btm += abs(*pr - ((*(re - max_w) + *(re + max_w)) >> 1));
      tmp_top += abs(*(pr + max_w) - ((*re + *(re + max_w * 2)) >> 1));
      tmp_btm += abs(*(re + max_w) - ((*pr + *(pr + max_w * 2)) >> 1));
      
      ++pr;
      ++re;
    }
    diff_top += tmp_top >> 4;
    diff_btm += tmp_btm >> 4;
  }

  _mm_empty();

  return abs(diff_top - diff_btm) >> (16 - gain);
}

//Ǒot[Ɉړ
void go_prev(void *editp, FILTER *fp)
{
  int n;
  int prev_tmp;

  if(g_rew_tail == g_rew_head) //
    n = 0;
  else{
    n = g_rew_tail>0 ? g_rew[g_rew_tail-1] : g_rew[REW_N-1];
    prev_tmp = REW_N-1==g_rew_head ? 0 : g_rew_head+1;
    if(prev_tmp != g_rew_tail)
      g_rew_tail = 0==g_rew_tail ? REW_N-1 : g_rew_tail-1;

    //ȂƂ\t[̑Oɖ߂
    while(n >= fp->exfunc->get_frame(editp)){
      n = g_rew_tail>0 ? g_rew[g_rew_tail-1] : g_rew[REW_N-1];
      prev_tmp = REW_N-1==g_rew_head ? 0 : g_rew_head+1;
      if(prev_tmp != g_rew_tail){
        g_rew_tail = 0==g_rew_tail ? REW_N-1 : g_rew_tail-1;
      }else{
        break;
      }
    }
  }

  fp->exfunc->set_frame(editp, n);
}


